#include "lista.h"

void cria(Lista *L) {
     L->inicio=NULL;
     L->fim=NULL;
}

void finaliza(Lista *L) {
     no *p;
     p=L->inicio;
     while (p!=NULL) {
           L->inicio=L->inicio->prox;
           free(p);
           p=L->inicio;
     }
     L->fim=NULL;
}

void inserir(Lista *L, elem x) {
     no *p;
     
     p=(no*) malloc(sizeof(no));
     p->info=x;
     p->prox=NULL;
     if (L->inicio==NULL)
        L->inicio=p;
     else L->fim->prox=p;
     L->fim=p;
             
}

void eliminar(Lista *L, elem x) {
     no *p, *aux;
     int teste=0;
     
     p=L->inicio;
     while ((p!=NULL) && (!teste)) {
           if (p->info==x) {
              if (p==L->inicio)
                 L->inicio=L->inicio->prox;
              else if (p==L->fim) {
                   L->fim=aux;
                   L->fim->prox=NULL;
              }
              else aux->prox=p->prox;
              free(p);
              teste=1;
           }
           else {
                aux=p;
                p=p->prox;
           }
     }     
}

void eliminar_rec(Lista* L, no* anterior, no* atual, elem x) {
     if (atual!=NULL) {
        if (atual->info==x) {
           if (atual==L->inicio)
              L->inicio=L->inicio->prox;
           else if (atual==L->fim) {
                L->fim=anterior;
                anterior->prox=NULL;
           }
           else anterior->prox=atual->prox;
           free(atual);                         
        }
        else eliminar_rec(L,atual,atual->prox,x);
     }
}

int tamanho(Lista *L) {
    no *p;
    int contador=0;

    p=L->inicio;
    while (p!=NULL) {
          contador++;
          p=p->prox;
    }
    return(contador);
}

int tamanho_rec(no* p) {
    if (p==NULL)
       return(0);
    else return(1+tamanho_rec(p->prox));
}

int esta_na_lista(Lista *L, elem x) {
    no *p;
     
    p=L->inicio;
    while ((p!=NULL) && (p->info!=x)) {
          p=p->prox;
    }
    
    if (p!=NULL) return 1;
    else return 0;
}

int esta_na_lista_rec(no *p, elem x) {
    if (p!=NULL) {
       if (p->info==x) return 1;
       else return(esta_na_lista_rec(p->prox,x));
    }
    else return 0;
}

void imprimir(Lista *L) {
     no *p;
     
     p=L->inicio;
     while (p!=NULL) {
           printf("%c ",p->info);
           p=p->prox;
     }
}
